struct Pixel;
class DNA;
class Animal;

class World
{
public:
	World( int imagec, char** imagev );

	void Display(); //OpenGL display function

	void FitnessCheck();
	void ImageCheck();

	void RenderChase();
	void RenderImage();
	void RenderVisible( Animal* a );
	void Resize( int w, int h ); //screen resize function
	void ScanDiffs(); //scan diffs and take appropriate actions

	void Load();
	void InsertAnimal( DNA* d );
	void Procreate( DNA* d );
	void Save();
	void ScreenShot( char* file );

	void CycleDisplayBuffer();
	void CycleDrawCreatures();
	void CycleCameraMode();
	void CycleChaseCam();
	void CycleImage();
	void Step();

	void Promote(); //promote back buffer to front

	Animal* pop; //ptr to highest-fitness animal
	int pop_c;

	Animal* chase; //chasecam target

	int fit_cycle;
	int image_cycle;

	char** image_v;
	int image_c;
	int image_i;

	int image_w, image_h;
	Pixel** image_p;

	int screen_w, screen_h;

	float world_l, world_r, world_t, world_b;

	int r_x, r_y, g_x, g_y, b_x, b_y; //pointers to strongest food

	float image_d; //starting diff total for the image
};
